/*
Created		07/11/2006
Modified		11/07/2007
Project		Spagic
Model		Bck Database
Company		Engineering
Author		Spagic Team
Version		2.0.0
Database    PostegreSQL
*/

Create table process_instance
(
	id_process_instance Bigint NOT NULL,
	id_parent_process_instance Bigint,
	id_process Bigint NOT NULL,
	startdate Timestamp NOT NULL,
	enddate Timestamp NOT NULL,
	executiontime Bigint,
	state Integer NOT NULL,
	id_correlation Varchar(100) NOT NULL,
	id_pool Bigint,
	id_process_execution_state Bigint NOT NULL Default 0,
 primary key (id_process_instance)
) Without Oids;


Create table transition_instance
(
	id_journal Bigint NOT NULL,
	id_step_source Bigint,
	id_step_target Bigint NOT NULL,
	id_process_instance Bigint NOT NULL,
	id_message Varchar(100) NOT NULL,
	transition_start Timestamp NOT NULL,
	transition_end Timestamp,
	transition_execution_time Bigint,
	id_ext_process_instance Bigint,
	id_state Integer NOT NULL,
	transition_data Text,
	transition_data_out Text,
	attachment_in Integer Default 0,
	attachment_out Integer Default 0,
	runtime_warning Boolean DEFAULT FALSE,
 primary key (id_journal)
) Without Oids;


Create table log_journal
(
	id_log Bigint NOT NULL,
	id_state Integer NOT NULL,
	id_journal Bigint NOT NULL,
	name Varchar(200),
	log Text NOT NULL,
	datelog Timestamp NOT NULL,
 primary key (id_log)
) Without Oids;

Create table relevant_data
(
	id_relevant_data Bigint NOT NULL,
	id_attribute Bigint NOT NULL,
	id_log Bigint NOT NULL,
	value Varchar(500) NOT NULL,
 primary key (id_relevant_data)
) Without Oids;

Create table pool_instance
(
	id_pool Bigint NOT NULL,
	id_pool_type Bigint NOT NULL,
	unique_pool_instance_key Varchar(1000) NOT NULL,
 primary key (id_pool)
) Without Oids;

Create table relevant_data_process_instance
(
	id_process_instance Bigint NOT NULL,
	id_relevant_data Bigint NOT NULL,
 primary key (id_process_instance,id_relevant_data)
) Without Oids;

CREATE VIEW main_relevant_data_process AS 
	SELECT r.id_process_instance, r.id_relevant_data, i.id_parent_process_instance
	FROM spagic.relevant_data_process_instance r, spagic.process_instance i
	WHERE r.id_process_instance = i.id_process_instance;

CREATE VIEW main_relevant_data AS 
	SELECT r.id_relevant_data, r.id_attribute, r.id_log, r.value, j.id_process_instance 
	FROM spagic.relevant_data r, spagic.log_journal l, spagic.transition_instance j, spagic.process_instance i 
	WHERE r.id_log=l.id_log 
	AND l.id_journal=j.id_journal 
	AND j.id_process_instance=i.id_process_instance; 

CREATE VIEW main_log_journal AS 
	SELECT l.id_log, l.id_state, l.id_journal, l.name, l.log, l.datelog, i.id_process_instance
	FROM spagic.log_journal l, spagic.transition_instance j, spagic.process_instance i 
	WHERE l.id_journal=j.id_journal 
	AND j.id_process_instance=i.id_process_instance;

CREATE VIEW main_transition_instance AS 
	SELECT j.id_journal, j.id_step_source, j.id_step_target, j.id_process_instance, j.id_message, j.transition_start, j.transition_end, j.id_ext_process_instance, j.id_state, j.transition_data 
	FROM  spagic.transition_instance j, spagic.process_instance i 
	WHERE j.id_process_instance=i.id_process_instance;

CREATE VIEW main_process_instance AS 
	SELECT i.id_process_instance, i.id_process, i.startdate, i.enddate, i.state, i.id_correlation, i.id_pool , id_parent_process_instance, id_process_execution_state
	FROM spagic.process_instance i;

CREATE VIEW main_pool_instance AS 
	SELECT i.id_pool, i.id_pool_type, i.unique_pool_instance_key 
	FROM spagic.pool_instance i;

CREATE VIEW main_temporary_process AS 
	SELECT id_process_instance FROM spagic.temporary_process_instance;